<script setup>
import {useUploadStore} from "@/stores/uploadStore";
import {computed, onMounted, reactive, ref} from "vue";
import {Bar} from "vue-chartjs";
import {Chart as ChartJS, Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale} from 'chart.js';
import {useTicketStore} from "@/stores/ticketStore";
import {useDepartmentStore} from "@/stores/departmentStore";
import {useAuthStore} from "@/stores/authStore";

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale);

const ticketStore = useTicketStore();
const departmentStore = useDepartmentStore();
const authStore = useAuthStore();
const ticketsForChart = computed(() => ticketStore.ticketsForChart);
const departments = computed(() => departmentStore.departments);
const news = ref({
  title: "News",
  article: "Wir ehren den herausragenden Einsatz\n" +
      "              und die außergewöhnliche Leistung unseres\n" +
      "              Mitarbeiters des Monats. Herzlichen Glückwunsch\n" +
      "              zu dieser wohlverdienten Anerkennung und\n" +
      "              inspirierenden Vorbildfunktion für das gesamte Team."
});
const announcements = ref({
  title: "Ankündigung",
  article: "Spannende Neuerungen im Unternehmen:\n" +
      "              Digitale Transformation für zukunftsweisende\n" +
      "              Erfolge. Mit Stolz präsentieren wir unsere\n" +
      "              innovative Plattform, die unsere Arbeitsprozesse\n" +
      "              revolutionieren wird. Nutzen Sie die Chancen der\n" +
      "              digitalen Ära, um effizienter zu arbeiten, bessere\n" +
      "              Ergebnisse zu erzielen und die Konkurrenz hinter sich\n" +
      "              zu lassen. Seien Sie Teil dieser bahnbrechenden Veränderung!"
})
let editNews = ref(false);
let editAnnouncements = ref(false);
const datasets = computed(() => [{
  label: 'Erledigte Tickets',
  data: departments.value.map(department => {
    return ticketsForChart.value
        .filter(ticket => ticket.department === department)
        .filter(ticket => ticket.ticketStatus === 'RESOLVED')
        .length
  })
}])

const isChartReady = ref(false)
const chartData = reactive({
  labels: departments,
  datasets
});

const chartOptions = {
  responsive: true
};

const uploadStore = useUploadStore();


onMounted(async () => {
  await departmentStore.getDepartments();
  await ticketStore.getAllTickets();
  await uploadStore.getFiles();

  isChartReady.value = true
})
</script>

<template>
  <v-main>
    <div class="main-style">
      <v-card class="mb-3 bg-blue-darken-4">
        <h2 class="m-3">Dashboard</h2>
      </v-card>

      <v-row>
        <v-col>
          <v-card>
            <h3 class="m-4" v-if="!editNews">{{news.title}}</h3>
            <v-divider></v-divider>
            <p class="m-4" v-if="!editNews">{{news.article}}</p>
            <v-text-field
                v-if="editNews"
                v-model="news.title"
                label="Title"
                type="text"/>
            <v-text-field
                v-if="editNews"
                v-model="news.article"
                label="Article"
                dense
                type="text"/>
            <v-divider></v-divider>
            <v-btn class="m-3" color="yellow-darken-3" v-if="authStore.user.role === 'ADMIN' && !editNews" @click="editNews = !editNews">Bearbeiten</v-btn>
            <v-btn class="m-3" color="green-darken-3" v-if="authStore.user.role === 'ADMIN' && editNews" @click="editNews = !editNews">Bestätigen</v-btn>
          </v-card>
        </v-col>
        <v-col>
          <v-card>
            <h3 class="m-4" v-if="!editAnnouncements">{{announcements.title}}</h3>
            <v-divider></v-divider>
            <p class="m-4" v-if="!editAnnouncements">{{announcements.article}}</p>
            <v-text-field
                v-if="editAnnouncements"
                v-model="announcements.title"
                label="Title"
                type="text"/>
            <v-text-field
                v-if="editAnnouncements"
                v-model="announcements.article"
                label="Article"
                type="text"/>
            <v-divider></v-divider>
            <v-btn class="m-3" color="yellow-darken-3" v-if="authStore.user.role === 'ADMIN' && !editAnnouncements" @click="editAnnouncements = !editAnnouncements">Bearbeiten</v-btn>
            <v-btn class="m-3" color="green-darken-3" v-if="authStore.user.role === 'ADMIN' && editAnnouncements" @click="editAnnouncements = !editAnnouncements">Bestätigen</v-btn>
          </v-card>
        </v-col>
      </v-row>
<!--      <v-row>
        <v-col>
          <v-card>
            <h2>Erledigte Tickets letzten Monat</h2>
            <p>Gewinner ist die IT Abteilung! Herzlichen Glückwunsch!</p>
            <img
                src="https://d2mvzyuse3lwjc.cloudfront.net/doc/de/UserGuide/images/Bar_Of_Pie_Chart/Bar_Of_Pie_Chart.png"
                alt="chart">
          </v-card>
        </v-col>
      </v-row>-->
      <v-row>
        <v-col>
          <v-card>
            <h2 class="m-4">Erledigte Tickets letzten Monat</h2>
            <p class="m-4">Gewinner ist die IT Abteilung! Herzlichen Glückwunsch!</p>
            <Bar
                class="m-5 border"
                v-if="isChartReady"
                id="my-chart-id"
                :options="chartOptions"
                :data="chartData"
            ></Bar>
          </v-card>

        </v-col>
      </v-row>


    </div>

  </v-main>

</template>

<style scoped>
.main-style {
  min-height: 90vh;
}
</style>